/* mrmacs.h
**
**
** some macros for simplifying pointer checks/memory allocation/...
*/
#ifndef _MRMACS_H
#define _MRMACS_H

#define isNULL(x) ((void *) (x) == NULL)
#define noNULL(x) ((void *) (x) != NULL)
#define alloct(t) ((t *) malloc (sizeof (t)))
#define alloctn(t, n) ((t *) malloc ((n) + sizeof (t)))
#define valloc(t, n) ((t *) malloc ((n) * sizeof (t)))
#define vresize(t, v, n) ((t *) realloc ((v), (n) * sizeof (t)))
#define if_alloct(t, v) if (noNULL((v) = alloct (t)))
#define unless_alloct(t, v) if (isNULL((v) = alloct(t)))
#define if_alloctn(t, v, n) if (noNULL((v) = alloctn(t, (n))))
#define unless_alloctn(t, v, n) if (isNULL((v) = alloctn(t, (n))))
#define if_valloc(t, v, n) if (noNULL((v) = valloc(t, (n))))
#define unless_valloc(t, v, n) if (isNULL((v) = valloc(t, (n))))
#define if_vresize(t, vt, vs, n) if (noNULL((vt) = vresize(t, (vs), (n))))
#define unless_vresize(t, vt, vs, n) if (isNULL((vt) = vresize(t, (vs), (n))))
#define ifnull(x) if (isNULL(x))
#define unlessnull(x) if (noNULL(x))

#endif /* defined(_MRMACS_H) */
